function ToMtask(tr1,tr2,subjectNo,runNo)
clearvars -except tr1 tr2 subjectNo runNo
close all
FullRuntime=GetSecs;
ToMtasksettings; % Load all the settings from the file
rand('state', sum(100*clock)); % Initialise random number generator
test=1; % 1 = outside o fscanner, 0 = in scanner

InitializePsychSound(1);

fileloc=[pwd '/'];
%%% load all data plus pre_loading images for later speed...
lddata = load(fullfile(fileloc, ['subject' subjectNo ], ['trialorder_run' num2str(runNo) '.mat']));
savedir = fullfile(fileloc, ['subject' subjectNo] , ['responses_run' num2str(runNo) '.mat']);
img1=cell(32,1);
img2=cell(32,1);
Face={32,1};
ImageFolder = fullfile(fileloc,'Images');
FaceFolder = fullfile(fileloc,'Faces');
for tt = 1:32
    img1{tt} = imread(fullfile(ImageFolder,lddata.ImgD{tt,1}));
    img2{tt} = imread(fullfile(ImageFolder,lddata.ImgD{tt,2}));
    Face{tt} = imread(fullfile(FaceFolder,lddata.Face{tt}));
end
lddata=[];

%loading the audio

wavfilenamePTb = fullfile(fileloc, 'audio', 'PTheirbelief.wav');

[yT, freqT] = readingaudio(wavfilenamePTb);

yT = yT(1500:27959,:);
wavedataPTB = yT';
nrchannelsT = size(wavedataPTB,1);
if nrchannelsT < 2
    wavedataPTB = [wavedataPTB ; wavedataPTB];
    nrchannelsT = 2;
end
pahandle = PsychPortAudio('Open', [], [], reqlatencyclass, freqT, 2, buffersize, suggestedLatencySecs);


wavfilenamePact = fullfile(fileloc, 'audio', 'PActually.wav');

[yR, freqR] = readingaudio(wavfilenamePact);
yR = yR(2000:28459,:);

wavedataPA = yR';
nrchannelsR = size(wavedataPA,1);
if nrchannelsR< 2
    wavedataPA = [wavedataPA ; wavedataPA];
    nrchannelsR = 2;
end

pahandlePA = pahandle;


wavfilenamePTC = fullfile(fileloc, 'audio', 'PTheirChoice.wav');

[yTi, freqTi] = readingaudio(wavfilenamePTC);
yTi = yTi(1000:27459,:);

wavedataTC = yTi';
nrchannelsTi = size(wavedataTC,1);
if nrchannelsTi < 2
    wavedataTC = [wavedataTC ; wavedataTC];
    nrchannelsTi = 2;
end
pahandlePTC = pahandle;

wavfilenamePYC = fullfile(fileloc, 'audio', 'Pyourchoice.wav');

[yK, freqK] = readingaudio(wavfilenamePYC);
yK = yK(1250:27710,:);
wavedataYC = yK';
nrchannelsK = size(wavedataYC,1);
if nrchannelsK < 2
    wavedataYC = [wavedataYC ; wavedataYC];
    nrchannelsK = 2;
end
pahandlePYC = pahandle;

wavfilenameTheirB = fullfile(fileloc, 'audio', 'theirbelief.wav');

[yT2, freqT2] = readingaudio(wavfilenameTheirB);
yT2 = yT2(1500:27959,:);

wavedataTB = yT2';
nrchannelsT2 = size(wavedataTB,1);
if nrchannelsT2 < 2
    wavedataTB = [wavedataTB; wavedataTB];
    nrchannelsT2 = 2;
end


pahandleTB = pahandle;

wavfilenameAc = fullfile(fileloc, 'audio', 'actually.wav');

[yR2, freqR2] = readingaudio(wavfilenameAc);
yR2 = yR2(1500:27959,:);

wavedataAc = yR2';
nrchannelsR2 = size(wavedataAc,1);
if nrchannelsR2 < 2
    wavedataAc = [wavedataAc; wavedataAc];
    nrchannelsR2 = 2;
end

pahandleAc = pahandle;

audDUR = size(yT,1)/freqT;

prelat = PsychPortAudio('LatencyBias', pahandle, latbias); %#ok<NOPRT,NASGU>
postlat = PsychPortAudio('LatencyBias', pahandle); %#ok<NOPRT,NASGU>

% Screen setup
clear screen
if test==1
    whichScreen = max(Screen('Screens'));
    [window1, rect] = Screen('Openwindow',whichScreen,backgroundColour,[],[],2);
else % in scanner
    [window1, rect] = Screen('Openwindow',1,backgroundColour,[],[],2);
end

% [center(1), center(2)] = RectCenter(rect);
HideCursor(window1)
slack = Screen('GetFlipInterval', window1)/2;
waitframes = ceil((2 * suggestedLatencySecs) / slack) + 1;
W=rect(RectRight); % screen width
H=rect(RectBottom); % screen height
Screen(window1,'FillRect',backgroundColour);
Screen('Flip', window1);


%%% load the box and shaddow of a person for the trials and set positions
sFimageFolder = 'PEOPLE/shadow';
sFace = imread(fullfile(sFimageFolder,'shadow.jpg'));
simageSize = size(sFace);
sFpos = [((W-simageSize(2))/2) 0 ((W+simageSize(2))/2) simageSize(1)]; % location to draw the  shaddow
sfaceDisplay = Screen('MakeTexture', window1, sFace); % shadow  to be used throughout

sBox = imread(fullfile(sFimageFolder,'box.jpg'));
sBimageSize = size(sBox);
BOXpos = [((W-simageSize(2))/2) ((3*H)/4)-(simageSize(1)) ((W+simageSize(2))/2) ((3*H)/4)]; % location to draw the box shaddow

boxDisplay = Screen('MakeTexture', window1, sBox); % box  to be used throughout

%%% position fo the image given teh positions of the box and shadow
pos = [(W/2)-175 sFpos(4)+45 (W/2)+175 BOXpos(2)-25];

% position for drawing lines and centre of the scanner screen
linePosup = -400;
linePosdown = +150;
CrossPosW = 'center';
CrossPosH = (BOXpos(2)-sFpos(4));

%%%% face position
imageSize = size(Face{1});
Fpos = [(W/2)-round(imageSize(2)/2) CrossPosH-round(imageSize(1)/2) (W/2)+round(imageSize(2)/2) CrossPosH+round(imageSize(1)/2)]; % location


%%load a blank image  to get psychtoolbox timings working
Cimg = imread(fullfile(ImageFolder,'clear.jpg'));


%%% Play dummy images and audio a few times to reduce possible lag during first exp stimuli
%%% set audio volume to 0 
PsychPortAudio('Volume', pahandle,0)
PsychPortAudio('Volume', pahandlePA,0)
PsychPortAudio('Volume', pahandlePYC,0)
PsychPortAudio('Volume', pahandlePTC,0)
PsychPortAudio('Volume', pahandleTB,0)
PsychPortAudio('Volume', pahandleAc,0)
for c=1:2
    PsychPortAudio('FillBuffer', pahandle, wavedataPTB);
    PsychPortAudio('Start', pahandle, 1, 0, 0);
    CimageDisplay1 = Screen('MakeTexture', window1, Cimg);
    Screen('Flip', window1); % Attempt to get timing working
    
    % WaitSecs(1)
    PsychPortAudio('FillBuffer', pahandlePA, wavedataPA);
    PsychPortAudio('Start', pahandlePA, 1, 0, 0);
    
    Screen('DrawTexture', window1, sfaceDisplay, [], sFpos);
    Screen(window1, 'FillRect', backgroundColour);
    CimageDisplay2 = Screen('MakeTexture', window1, Cimg);
    Screen('Flip', window1); % Attempt to get timing working
    Screen(CimageDisplay1,'Close');
    % WaitSecs(1)
    PsychPortAudio('FillBuffer', pahandlePYC, wavedataYC);
    PsychPortAudio('Start', pahandlePYC, 1, 0, 0);
    
    
    Screen(window1, 'FillRect', backgroundColour);
    
    CimageDisplay3 = Screen('MakeTexture', window1, Cimg);
    Screen('Flip', window1); % Attempt to get timing working
    Screen(CimageDisplay2,'Close');
    % WaitSecs(1)
    PsychPortAudio('FillBuffer', pahandlePTC, wavedataTC);
    PsychPortAudio('Start', pahandlePTC, 1, 0, 0);
    
    CimageDisplay4 = Screen('MakeTexture', window1, Cimg);
    Screen('Flip', window1); % Attempt to get timing working
    
    Screen(CimageDisplay3,'Close');
    PsychPortAudio('FillBuffer', pahandleAc, wavedataAc);
    PsychPortAudio('Start', pahandleAc, 1, 0, 0);
    %     img2 = imread(fullfile(imageFolder,ImgD{c,2}));
    %     imageDisplay2 = Screen('MakeTexture', window1, img2);
    Screen(window1, 'FillRect', backgroundColour);
    CimageDisplay5 = Screen('MakeTexture', window1, Cimg);
    Screen('Flip', window1); % Attempt to get timing working
    Screen(CimageDisplay4,'Close');
    
    PsychPortAudio('FillBuffer', pahandleTB, wavedataTB);
    PsychPortAudio('Start', pahandleTB, 1, 0, 0);
    CimageDisplay6 = Screen('MakeTexture', window1, Cimg);
    Screen('Flip', window1); % Attempt to get timing working
    % WaitSecs(1)
    Screen(CimageDisplay5,'Close');
    Screen(CimageDisplay6,'Close');
    %     Screen(imageDisplay1,'Close');
    %     Screen(imageDisplay2,'Close');
end
WaitSecs(1)
PsychPortAudio('Volume', pahandle,1)
PsychPortAudio('Volume', pahandlePA,1)
PsychPortAudio('Volume', pahandlePYC,1)
PsychPortAudio('Volume', pahandlePTC,1)
PsychPortAudio('Volume', pahandleTB,1)
PsychPortAudio('Volume', pahandleAc,1)


% pre set variables
questionA =zeros(1,size(ImgT,1)); % pre-set variable used to collect the button presses
qRT= zeros(1,size(ImgT,1)); % pre-set variable used to collect the reaction times for take it leave it question

TrialTime =  zeros(1,size(ImgT,1));

probeseq = [zeros(1,size(ImgT,1)/2),ones(1,size(ImgT,1)/2)];
probeseq = probeseq(randperm(size(ImgT,1)));
ISI = zeros(1,size(ImgT,1));
ISI(1:size(ImgT,1)/2) = ISIt(1);
ISI((size(ImgT,1)/2)+1:end) = ISIt(2);

ISI = ISI(randperm(size(ImgT,1)));
s1Stime = zeros(1,size(ImgT,1));
S1startT = zeros(1,size(ImgT,1));
StartT=zeros(1,size(ImgT,1));
encodingT = zeros(1,size(ImgT,1));
Facetiming=zeros(1,size(ImgT,1));
S2startT=zeros(1,size(ImgT,1));
qPROBEstartT=zeros(1,size(ImgT,1));
checkprobeT =zeros(1,size(ImgT,1));
MVPAstartT=zeros(1,size(ImgT,1));


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%% Start of experiment!!!
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Screen('TextFont',window1, 'Arial');
Screen('TextSize',window1, maintextsize);
% Start screen
DrawFormattedText(window1,'Have fun!',CrossPosW,CrossPosH) % will be from trigger in scanner
Screen('Flip',window1);


%%% wait for the scanner trigger...

cleanpport(); %clear all parallel pins
dio = digitalio('parallel', 'LPT1');  %set up parallel port
addline(dio,1:16,'in');
addline(dio,0,'out');

pins = getvalue(dio);
while pins(11) == 0
    pins = getvalue(dio);
    if(pins)
        break;
    end
end

TimeTRIGstart=GetSecs;
DrawFormattedText(window1,'X',CrossPosW,CrossPosH);
Screen('Flip', window1);
WaitSecs(onsetoffsetdur-slack);


% experimental trials
Priority(MaxPriority(window1));
for t = tr1:tr2
    
    DrawFormattedText(window1,'X',CrossPosW,CrossPosH);
    StartT(t) = Screen('Flip', window1);
    WaitSecs(ISI(t)-slack);
    
    %%%%%% Set up images and face for this trial
    imageDisplay1 = Screen('MakeTexture', window1, img1{t});
    
    imageDisplay2 = Screen('MakeTexture', window1, img2{t});
    
    faceDisplay = Screen('MakeTexture', window1, Face{t});
    
    %display face for set duration
    Screen('DrawTexture', window1, faceDisplay, [], Fpos);
    [Facetiming(t), ptime]= Screen('Flip', window1);
    
    WaitSecs(faceduration-slack);
    
    
    %pre-load the box and figure shadow for the trial
    Screen(window1, 'FillRect', backgroundColour);
    Screen('DrawTexture', window1, sfaceDisplay, [], sFpos);
    Screen('DrawTexture', window1, boxDisplay, [], BOXpos);
    
    if abs(ImgT(t,1))==2 % Actually trial is first
        Screen('DrawLine', window1, 0,(W/2),LinePosdown, (W/2),(H/2)+LinePosdownS,6);
        PsychPortAudio('FillBuffer', pahandleAc, wavedataAc);
        
        Screen('DrawTexture', window1, imageDisplay1, [], pos);
        [S1startT(t), sPtime] = Screen('Flip', window1);
        PsychPortAudio('Start', pahandleAc, 1,S1startT(t), 1);
        
        WaitSecs(StimDUR-slack);
        
        centredot(window1, pausingfor-slack,backgroundColour);
        
        %second trial is Their belief
        Screen(window1, 'FillRect',  backgroundColour);
        Screen('DrawTexture', window1, sfaceDisplay, [], sFpos);
        Screen('DrawTexture', window1, boxDisplay, [], BOXpos);
        Screen('DrawLine', window1, 0,(W/2),(H/2)+linePosup, (W/2),LinePosupS,6);
        
        PsychPortAudio('FillBuffer', pahandleTB, wavedataTB);
        PsychPortAudio('Start', pahandleTB, 1,sPtime+(StimDUR-slack)+(pausingfor-slack)+waitframes*slack, 1);
        
    else
        %first trial is Their belief, second is actually.
        Screen('DrawLine', window1, 0,(W/2),(H/2)+linePosup, (W/2),LinePosupS,6);
        PsychPortAudio('FillBuffer', pahandleTB, wavedataTB);
        
        Screen('DrawTexture', window1, imageDisplay1, [], pos);
        [S1startT(t), sPtime] = Screen('Flip', window1); %
        PsychPortAudio('Start', pahandleTB, 1,S1startT(t), 1);
        
        WaitSecs(StimDUR-slack);
        
        centredot(window1, pausingfor-slack,backgroundColour);
        
        Screen(window1, 'FillRect',  backgroundColour);
        Screen('DrawTexture', window1, sfaceDisplay, [], sFpos);
        Screen('DrawTexture', window1, boxDisplay, [], BOXpos);
        Screen('DrawLine', window1, 0,(W/2),LinePosdown, (W/2),(H/2)+LinePosdownS,6);
        
        PsychPortAudio('FillBuffer', pahandleAc, wavedataAc);
        PsychPortAudio('Start', pahandleAc, 1,sPtime+(StimDUR-slack)+(pausingfor-slack)+waitframes*slack, 1);
    end
    
    Screen('DrawTexture', window1, imageDisplay2, [], pos);
    [S2startT(t), tset]= Screen('Flip', window1); %
    
    WaitSecs(StimDUR-slack);
    
    %set up balnk screen for the encoding period
    encodingT(t) = centredot(window1, encodingprobedelay-slack,backgroundColour);
    % play audio with balnk screen for Probe1
    if sum(ismember(ImgT(t,:),-2)) %actualy image probed
        MVPAstartT(t) = DATAsection(window1, (MVPAarea-slack) ,backgroundColour,pahandlePA,wavedataPA,audDUR);
    else % belief image probed
        MVPAstartT(t) = DATAsection(window1, (MVPAarea-slack) ,backgroundColour,pahandle,wavedataPTB,audDUR);
    end
    if Qs(t)==1 %% Your choice
        qPROBEstartT(t) = DATAsection(window1, (qPROBE-slack),backgroundColour,pahandlePYC,wavedataYC,audDUR);
    else % Their Choice
        qPROBEstartT(t) = DATAsection(window1, (qPROBE-slack),backgroundColour,pahandlePTC,wavedataTC,audDUR);
    end
    [questionA(t), qRT(t), checkprobeT(t)] = checkprobedraw(window1,'Take it / Leave it','','','',(answerdur-slack), probetextsize,maintextsize,CrossPosW,CrossPosH);
    
    
    Screen(imageDisplay1,'Close');
    Screen(imageDisplay2,'Close');
    Screen(faceDisplay,'Close');
    TrialTime(t) = GetSecs;
end
DrawFormattedText(window1,'X',CrossPosW,CrossPosH);
Screen('Flip', window1);

WaitSecs(onsetoffsetdur-slack);
%%%%%%% saving info %%%%%%%%

TimeTOTAL=GetSecs-TimeTRIGstart;
FullRuntimeEND = GetSecs-FullRuntime;
save(savedir,'audDUR','checkprobeT','encodingT','RT','qRT','TimeTRIGstart','MVPAstartT','qPROBEstartT','S1startT','Facetiming','FullRuntimeEND','slack','StartT','TrialTime','questionA','TimeTOTAL','ISI','probeseq','S2startT');
ShowCursor
close all
PsychPortAudio('Close');
sca;
return

end

function [y,freq] = readingaudio(wavfileN) % for different versions of matlab and psychtoolbox
try
    [y, freq] = psychwavread(wavfileN);
catch
    try
        [y, freq] = audioread(wavfileN);
        
    catch
        [y, freq] =wavread(wavfileN);
    end
end

end
%%%%%%%%%%%between stimuli draw a dot, or just blank....
function [timeflip] =  centredot(window1, TIME ,backgroundColour)
Screen(window1, 'FillRect', backgroundColour);
timeflip = Screen('Flip', window1, [],0);
WaitSecs(TIME)
end

%%%%%%%%%%%between stimuli draw a dot, + or just blank....
function [timeflip] =  DATAsection(window1, TIME ,backgroundColour,handle,wavtodo,aDUR)
PsychPortAudio('FillBuffer', handle, wavtodo);
Screen(window1, 'FillRect', backgroundColour);
timeflip = Screen('Flip', window1, [],0);
PsychPortAudio('Start', handle, 1, timeflip, 1,timeflip+aDUR);%timeflip+aDUR
WaitSecs(TIME)
end

function [pr rt,tTextdisplay]= checkprobedraw(window1,Prb,frst,secnd,joining,PRB,  probetextsize,maintextsize,c1,c2)

DrawFormattedText(window1,Prb,c1,c2);
Screen('TextSize',window1, probetextsize);
pr=-10;
rt=-10;
DrawFormattedText(window1,[frst joining secnd],c1,c2+40);
tTextdisplay = Screen('Flip', window1,[],0);
while (GetSecs-tTextdisplay)<(PRB)
    if pr==-10
        [keyIsDown,secs,keyCode] = KbCheck;
        if keyCode(190)==1 %% pressed right: keycode 190 on windows; 56 buic
            pr = 1;
            rt = GetSecs-tTextdisplay;
        elseif keyCode(188)==1%% pressed left: keycode 188 windows, 57 buic
            pr = 2;
            rt = GetSecs-tTextdisplay;
        end
    end
end
Screen('TextSize',window1, maintextsize);
end